<?php
define("THIS_FILE", "update.php");

function getConstValue($name) {
  return (defined($name) ? constant($name) : "");
}
function readOldConfigData() {
  KDbConfig::setOrganisationName(getConstValue("ORGANISATION_NAME"));
  KDbConfig::setRootEmail(getConstValue("ROOT_EMAIL"));
  KDbConfig::setAllowUserLogin(getConstValue("ALLOW_USER_LOGIN"));
  KDbConfig::setDisableFileUpload(getConstValue("DISABLE_FILE_UPLOAD"));
  KDbConfig::setEnableMultipleRegistration(getConstValue("ENABLE_MULTIPLE_REGISTRATION"));
  KDbConfig::setEmailDuplicates(getConstValue("EMAIL_DUPLICATES"));
  KDbConfig::setCssSkin(getConstValue("CSS_SKIN"));
  KDbConfig::setUseLang(getConstValue("USE_LANG"));
  KDbConfig::setDefaultLang(getConstValue("DEFAULT_LANG"));
  KDbConfig::setDbHost(getConstValue("DB_HOST"));
  KDbConfig::setDbName(getConstValue("DB_NAME"));
  KDbConfig::setDbUser(getConstValue("DB_USER"));
  KDbConfig::setDbPasswd(getConstValue("DB_PASSWD"));
  KDbConfig::setAdminLoginMode(getConstValue("ADMIN_LOGIN_MODE"));
  KDbConfig::setCurrency(getConstValue("CURRENCY"));
  KDbConfig::setUserProperties(getConstValue("USER_PROPERTIES"));
  KDbConfig::setUserPropertiesReq(getConstValue("USER_PROPERTIES_REQ"));
  KDbConfig::setKdbConfirmationText(getConstValue("KDB_CONFIRMATION_TEXT"));
  KDbConfig::setKdbConfirmationEmail(getConstValue("KDB_CONFIRMATION_EMAIL"));
  KDbConfig::setReturnpathWorkaround(getConstValue("RETURNPATH_WORKAROUND"));
}


error_reporting(E_ALL ^ E_NOTICE);
set_time_limit(600);

require_once("../k_db/KDbConfig.inc.php");
require_once("../config/config.inc.php");
if(defined("ORGANISATION_NAME")) readOldConfigData();
  
require_once("KDbTools.inc.php");
require_once("MainAdminUI.inc.php");
require_once("autoloader.inc.php");
autoloader::init();

CWFTools::replaceHTMLChars($_POST);
$DB = new DbConnection(KDbConfig::getDbHost(), KDbConfig::getDbUser(), KDbConfig::getDbPasswd(), KDbConfig::getDbName());

$menu = new MainAdminUI($DB, false);

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Update statements
$UPDATES_SQL = array(
  "3.0 &alpha;11" => array(
      "ALTER TABLE users ADD COLUMN deleted tinyint;",
      "UPDATE users SET deleted=0;",
      "ALTER TABLE user_booking ADD COLUMN deleted tinyint;",
      "UPDATE user_booking SET deleted=0;",
      "ALTER TABLE user_booking_options ADD COLUMN deleted tinyint;",
      "UPDATE user_booking_options SET deleted=0;",
      "CREATE TABLE k_db_version(version text);",
      "INSERT INTO k_db_version(version) VALUES('3.0 &alpha;11');"
  ),
  "3.0 &alpha;12" => array(
      "ALTER TABLE events DROP COLUMN event_currency;",
      "UPDATE k_db_version SET version='3.0 &alpha;12';"
  ),
  "3.0 &alpha;13" => array(
      "ALTER TABLE users ADD COLUMN last_login datetime AFTER allow_email;",
      "UPDATE k_db_version SET version='3.0 &alpha;13';"
  ),
  "3.0 &alpha;14" => array(
      "ALTER TABLE user_booking ADD INDEX user_id (user_id);",
      "ALTER TABLE user_booking ADD INDEX event_id (event_id);",
      "ALTER TABLE event_fees ADD INDEX event_option_id (event_option_id);",
      "ALTER TABLE event_options ADD INDEX event_option_group_id (event_option_group_id);",
      "ALTER TABLE event_option_groups ADD INDEX event_id (event_id);",
      "ALTER TABLE kdb_log ADD INDEX db_admin_id (db_admin_id);",
      "ALTER TABLE event_options CHANGE COLUMN person_limit person_limit mediumint unsigned;",
      "UPDATE k_db_version SET version='3.0 &alpha;14';"
  ),
  "3.0 &beta;2" => array(
      "RENAME TABLE k_db_version TO kdb_version;",
      "UPDATE kdb_version SET version='3.0 &beta;2';"
  ),
  "3.0 rc8" => array(
      "ALTER TABLE db_admins ADD COLUMN admin_name text AFTER db_admin_id;",
      "UPDATE db_admins SET admin_name='root' WHERE login='root';",
      "UPDATE kdb_version SET version='3.0 rc8';"
  ),
  "3.0.0" => array(
      "ALTER TABLE events ADD COLUMN confirmation_email_wl text AFTER confirmation_email;",
      "ALTER TABLE events ADD COLUMN confirmation_text_wl text AFTER confirmation_email;",
      "UPDATE kdb_version SET version='3.0.0';"
  ),
  "3.1.0" => array(
      "CREATE TABLE db_admins_access (db_admin_id int unsigned NOT NULL, name varchar(100) NOT NULL, PRIMARY KEY(db_admin_id, name), INDEX(db_admin_id));",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'kdb_options' FROM db_admins WHERE kdb_options>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_event' FROM db_admins WHERE edit_event>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_fees' FROM db_admins WHERE edit_fees>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_payment' FROM db_admins WHERE edit_payment>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_disclaimers' FROM db_admins WHERE edit_disclaimers>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_salutations' FROM db_admins WHERE edit_salutations>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_topics' FROM db_admins WHERE edit_topics>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_views' FROM db_admins WHERE edit_views>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_admins' FROM db_admins WHERE edit_admins>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_admingroups' FROM db_admins WHERE edit_admingroups>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'add_registrations' FROM db_admins;",
      "ALTER TABLE db_admins DROP COLUMN kdb_options, DROP COLUMN edit_event, DROP COLUMN edit_fees, DROP COLUMN edit_payment, ".
      "DROP COLUMN edit_disclaimers, DROP COLUMN edit_salutations, DROP COLUMN edit_topics, DROP COLUMN edit_views, DROP COLUMN edit_admins, ".
      "DROP COLUMN edit_admingroups;",
      "UPDATE kdb_version SET version='3.1.0';"
  ),
  "3.2.0" => array(
      "ALTER TABLE views ADD COLUMN hidden_columns text AFTER columns;",
      "ALTER TABLE views ADD COLUMN sort_column text;",
      "ALTER TABLE views ADD COLUMN sort_desc tinyint;",
      "UPDATE kdb_version SET version='3.2.0';"
  ),
  "3.3 rc2" => array(
      "ALTER TABLE events CHANGE COLUMN db_admin_group_id db_admin_group_id int unsigned;",
      "UPDATE events SET reg_start=null WHERE reg_start=0;",
      "UPDATE events SET reg_end=null WHERE reg_end=0;",
      "ALTER TABLE event_option_groups ADD COLUMN description text AFTER required;",
      "ALTER TABLE event_options ADD COLUMN list text AFTER option_type;",
      "ALTER TABLE event_options ADD COLUMN booking_limit mediumint unsigned AFTER person_limit;",
      "UPDATE event_options SET booking_limit=0;",
      "UPDATE event_fees SET deadline=null WHERE deadline=0;",
      "ALTER TABLE user_booking ADD COLUMN change_log text AFTER booking_date;",
      "ALTER TABLE user_booking_options ADD COLUMN value_int int AFTER value_str;",
      "UPDATE user_booking_options SET value_int=1 WHERE event_fee_id>0;",
      "UPDATE kdb_version SET version='3.3 rc2';"
  ),
  "3.3 rc3" => array(
      "ALTER TABLE event_option_groups ADD COLUMN enable_waitlist tinyint AFTER allow_changes;",
      "UPDATE event_option_groups eog SET enable_waitlist=IF(group_type='".OPTION_GROUP_FEES."', (SELECT ifnull(enable_waitlist, 0) FROM events e WHERE e.event_id=eog.event_id), 0);",
      "UPDATE kdb_version SET version='3.3 rc3';"
  ),
  "3.4 rc1" => array(
      "ALTER TABLE user_booking_check ADD COLUMN partial_payment int AFTER payment_received;"
  ),
  "3.4.0" => array(
      "ALTER TABLE user_booking_options ADD INDEX event_option_id (event_option_id);",
      "ALTER TABLE user_booking_options ADD INDEX event_fee_id (event_fee_id);"
  ));
// Create db tables for new classes
$NEWCLASSES = array(
  "3.0 rc7" => array("Country"),
  "3.2.0"   => array("EmailTemplate")
);
$UPDATES_CONF = array(
  "3.0 &alpha;12" => array(
      "currency"=>"€"
  ),
  "3.0 rc7" => array(
      "returnpath_workaround"=>0
  ),
  "3.3.0" => array(
  )
);

if ($menu->writeHeader(THIS_FILE, 'K_DB Update', '')) {
  echo "<h2 class=\"first\">K_Db Update</h2>\n";

  $kdbVersion = $DB->result($DB->query("SELECT version FROM kdb_version LIMIT 1;"), 0, 0);
  if($DB->error())
    $kdbVersion = $DB->result($DB->query("SELECT version FROM k_db_version LIMIT 1;"), 0, 0);
    
  if($kdbVersion!=KDB_VERSION) {
    echo "<p>Updating K_Db".($kdbVersion ? " from version {$kdbVersion}" : "")." to ".KDB_VERSION."</p>\n";
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Update Database
    echo "<h4>Update database ...</h4>\n";
    if(!in_array(KDB_VERSION, array_keys($UPDATES_SQL)))
      $UPDATES_SQL[KDB_VERSION] = array("UPDATE kdb_version SET version='".KDB_VERSION."';");
    
    do {
      if (key($UPDATES_SQL)>$kdbVersion) break;
    } while($kdbVersion && next($UPDATES_SQL));
    
    echo "<table class=\"padding alignleft borderrows\">\n";
    while($update = current($UPDATES_SQL)) {
      foreach($update as $sql) {
        echo "<tr>\n";
        echo "  <td>{$sql}</td>\n";
        $DB->query($sql);
        if(!$DB->errno())
          echo "  <td>Success</td>\n";
        else
          echo "  <td><b>".$DB->error()."</b></td>\n";
        echo "</tr>\n";
      }
      next($UPDATES_SQL);
    }
    echo "</table>\n";

    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // New classes
    echo "<h4>Create tables for new classes ...</h4>\n";
    do {
      if (key($NEWCLASSES)>$kdbVersion) break;
    } while($kdbVersion && next($NEWCLASSES));
    
    echo "<table class=\"padding alignleft borderrows\">\n";
    while($update = current($NEWCLASSES)) {
      foreach($update as $newClass) {
        echo "<tr>\n";
        echo "  <td>{$newClass}</td>\n";
        echo "  <td>";
        $newClass::createTable($DB);
        echo "</td>\n";
        echo "</tr>\n";
      }
      next($NEWCLASSES);
    }
    echo "</table>\n";
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Update configuration file
    echo "<h4>Update configuration file ...</h4>\n";
    do {
      if (key($UPDATES_CONF)>$kdbVersion) break;
    } while($kdbVersion && next($UPDATES_CONF));
    
    echo "<table class=\"padding alignleft borderrows\">\n";

    if($update = current($UPDATES_CONF)) {
      $config = new KDbOptions(KDbOptionsUI::getValidationRules());
      $newConfArray = $config->toArray();
      do {
        foreach($update as $const => $value) {
          echo "<tr>\n";
          echo "  <td>$const</td>\n";
          echo "  <td>$value</td>\n";
          echo "</tr>\n";
          $newConfArray[$const] = $value;        
        }
      } while($update = next($UPDATES_CONF));
      if($config->fromArray($newConfArray)) {
        $config->writeData($DB);
        echo "<tr>\n  <td><b>Update status:</b></td>\n  <td>Success</td>\n</tr>";
      }
      else
        echo "<tr>\n  <td><b>Update status:</b></td>\n  <td>Validation failed.</td>\n</tr>";
    }
    else {
      echo "<tr>\n  <td><b>Update status:</b></td>\n  <td>Nothing to do.</td>\n</tr>";
      $config = new KDbOptions(KDbOptionsUI::getValidationRules());
      $config->writeData($DB);
    }
    
    echo "</table>\n";
  }
  else {
    echo "<p>K_Db database and configuration are up to date (v{$kdbVersion})</p>\n";
  }
?>


<?php
}
$menu->writeFooter();
?>
