<?php
require_once("../config/config.inc.php");
require_once("DbConnection.inc.php");
require_once("CWFTools.inc.php");
require_once("Plugins.inc.php");
require_once("autoloader.inc.php");
autoloader::init();

$session = "";
$userSession = null;
if(preg_match("~^{$_SERVER['SCRIPT_NAME']}/([A-Za-z0-9_/-]+)(\?.*)?$~", $_SERVER['REQUEST_URI'], $match)) {
  $session = $match[1];
  CWFTools::startSession($session, "");
  
  if(preg_match('~_admin$~', $session))
    $userSession = $_SESSION['admin'];
  else
    if(isset($_SESSION['user']))
      $userSession = $_SESSION['user'];
}
CWFTools::replaceHTMLChars($_POST);

if(isset($_SESSION['admin']))
  include_once(KDbConfig::getCwfPath()."plugins/plugins_admin.inc.php");
else
  include_once(KDbConfig::getCwfPath()."plugins/plugins.inc.php");
  
putenv("LC_ALL={$_SESSION['lang']}");
setlocale(LC_ALL, $_SESSION['lang']);
bindtextdomain("default", KDbConfig::getCwfPath()."locale");
textdomain("default");
bind_textdomain_codeset("default", "UTF-8");

$xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?".">\n";
$xml .= "<formContent>\n";

if(!isset($_POST["className"])) {
  $xml .= "  <errorMessage>"._("No class chosen.")."</errorMessage>\n";
}
else {
  $class = $_POST["className"];
  $DB = new DbConnection(KDbConfig::getDbHost(), KDbConfig::getDbUser(), KDbConfig::getDbPasswd(), KDbConfig::getDbName());
  switch($class) {
    case "Event":
      $instance = new $class();
      break;
    default:
      $instance = new $class($DB);
      break;
  }
  
  if ($session && !$userSession) {
    $xml .= "  <errorMessage>"._("Not logged in.")."</errorMessage>\n";
  }
  else if(!isset($_POST["action"])) {
    $xml .= "  <errorMessage>"._("Action not set.")."</errorMessage>\n";
  }
  else if ($_POST["action"]=="chooseEvent") {
    //For this action $_POST['className'] is not a ui class
    $errorMsg = "";
    if($_POST['className']=="Event") {
      $id = $_POST["id"];
      if($id<=0) {
        unset($_SESSION['event']);
      }
      else {
        list($errno, $error) = $instance->readData($DB, array($instance->getIDName()=>$id));
        if ($errno)
          $errorMsg = _("Error")." {$errno}: {$error}";
        else if(isset($_SESSION['admin'])) {
          if ($_SESSION['admin']['login']=="root" || $instance->db_admin_group_id==0 ||
              in_array($instance->db_admin_group_id, $_SESSION['admin']['db_admin_group_ids']))
            $_SESSION['event'] = clone $instance;
          else
            $errorMsg = _("You do not have enough privileges.");
        }
        else
          $_SESSION['event'] = clone $instance;
      }
    }
    if($errorMsg)
      $xml .= "  <errorMessage>{$errorMsg}</errorMessage>\n";
    $xml .= "  <selectedEntry>{$id}</selectedEntry>\n";
  }
  else if(!$class::isAllowedAction($_POST["action"])) {
    $xml .= "  <errorMessage>"._("Action not allowed.")."</errorMessage>\n";
  }
  else if (isset($_SESSION['user']) && isset($_POST["user_id"]) && $_POST["user_id"]!=$_SESSION['user']->user_id) {
    $xml .= "  <errorMessage>"._("You do not have enough privileges.")."</errorMessage>\n";
  }
  else if (!isset($_SESSION['user']) && $err = $class::checkPrivileges($userSession, $_POST["action"])) {
    $xml .= "  <errorMessage>{$err}</errorMessage>\n";
  }
  else {
    $id = $instance->doAction($DB, $_POST["action"]);  
    if(!$instance->isValid($_POST['action'])) {
      foreach($instance->getInvalidFields() as $name=>$message)
        $xml .= "  <notValid name=\"$name\">$message</notValid>\n";
    }
    else {
      if($instance->getErrorMessage())
        $xml .= "  <errorMessage>{$instance->getErrorMessage()}</errorMessage>\n";
      else
        $xml .= $instance->getPostBackXML($DB, $_POST["action"]);
    }
    $xml .= "  <selectedEntry>{$id}</selectedEntry>\n";
  }
}

$xml .= "</formContent>\n";

header('Content-type: text/xml');
echo $xml;
