<?php
require_once("cwfUI.inc.php");

class EventListUI extends cwfUI {
  public function __construct() {
    parent::__construct();
    $this->data = null;
    $this->title = _("Events");
    $this->header = "";
  }
  
  public function getErrorMessage() {
    return "";
  }
  
  public function getHTML(DbConnection $DB) {
    echo "<h2 class=\"first\">"._("Current events")."</h2>\n\n";
  
    $tooltipStr = array();
    $activeEvents = Event::getList($DB, array("active"=>"1"), $error);
    if (is_array($activeEvents) && count($activeEvents=array_filter($activeEvents, function($item) { return $item->has_form; }))>0) {
      echo "<table class=\"padding alignleft borderrows\">\n";
      
      echo "<tr>\n";
      echo "  <th><b>"._("Event")."</b></th>\n";
      echo "  <th><b>"._("Period")."</b></th>\n";
      echo "  <th><b>"._("Location")."</b></th>\n";
      echo "  <th><b>"._("Email")."</b></th>\n";
      echo "  <th><b>"._("Registration")."</b></th>\n";
      echo "</tr>\n";
  
      foreach($activeEvents as $event) {
        if ($event->event_description)  
          $tooltipStr[$event->event_id] = nl2br($event->event_description);
  
        echo "<tr id=\"event_{$event->event_id}\"";
        if (isset($_SESSION['event']) && $event->event_id==$_SESSION['event']->event_id)
          echo " class=\"selected_event with_tooltip persistant\"";
        else
          echo " class=\"with_tooltip persistant\"";
        echo ">\n";
        
        echo "  <td>";
        if (in_array($event->event_status, array(EVENT_OPEN, EVENT_REGISTERED, EVENT_WAITLIST)))
          echo "<a href=\"?event_id={$event->event_id}\">";
          
        echo "{$event->event_title}";
        if (in_array($event->event_status, array(EVENT_OPEN, EVENT_REGISTERED, EVENT_WAITLIST)))
          echo "</a>";
        echo "</td>\n";
        
        echo "  <td>{$event->event_period}</td>\n";
        echo "  <td>{$event->event_location}</td>\n";
        echo "  <td><a href=\"mailto:{$event->event_email}\">{$event->event_email}</a></td>\n";
        echo "  <td>".$event->getStatus()."</td>\n";
        echo "</tr>\n";    
      }
      echo "</table>\n";
    }
    else
      echo _("No entries found.");
   
    $tooltipStrVisited = array();
    if(isset($_SESSION['user'])) {
      echo "<h3>"._("Visited events")."</h3>\n\n";
    
      $visitedEvents = Event::getBookedEvents($DB, $_SESSION['user']->user_id);
      if (count($visitedEvents)>0) {
        echo "<table class=\"padding alignleft borderrows\">\n";
              
        echo "<tr>\n";
        echo "  <th><b>"._("Event")."</b></th>\n";
        echo "  <th><b>"._("Period")."</b></th>\n";
        echo "  <th><b>"._("Location")."</b></th>\n";
        echo "  <th><b>"._("Email")."</b></th>\n";
        echo "</tr>\n";
              
        foreach($visitedEvents as $event) {
          if ($event['event_description'])  
            $tooltipStrVisited[$event['event_id']] = nl2br($event['event_description']);
  
          echo "<tr id=\"event_{$event['event_id']}\"";
          if (isset($_SESSION['event']) && $event['event_id']==$_SESSION['event']->event_id)
            echo " class=\"selected_event with_tooltip\"";
          else
            echo " class=\"with_tooltip\"";
          echo ">\n";
          echo "  <td>{$event['event_title']}</td>\n";
          echo "  <td>{$event['event_period']}</td>\n";
          echo "  <td>{$event['event_location']}</td>\n";
          echo "  <td><a href=\"mailto:{$event['event_email']}\">{$event['event_email']}</a></td>\n";          
          echo "</tr>\n";    
        }
        
        echo "</table>\n\n";
      }
      else
        echo _("No entries found.");
    }
  
    foreach ($tooltipStr as $event_id=>$tt_text) {
      echo "<span id=\"tt_event_{$event_id}\" class=\"tooltip persistant\">$tt_text</span>\n";
    }
    foreach ($tooltipStrVisited as $event_id=>$tt_text) {
      echo "<span id=\"tt_event_{$event_id}\" class=\"tooltip persistant\">$tt_text</span>\n";
    }
  }
}

?>